SystemOrganization addCategory: #'Seaside-Pharo-Tools-Spec'!

Object subclass: #WAPharoToolsIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons Instance'
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAPharoToolsIcons class methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 17:46'!
default
	^ Instance ifNil: [ Instance := self new ]! !

!WAPharoToolsIcons class methodsFor: 'private' stamp: 'StephanEggermont 8/31/2012 17:46'!
findIcon: aSymbol
	(self canUnderstand: aSymbol)
		ifTrue: [ ^ self default perform: aSymbol ].
	^ UITheme current
		iconNamed: ('small' , aSymbol capitalized) asSymbol
		ifNone: [ UITheme current iconNamed: aSymbol ]! !

!WAPharoToolsIcons class methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 17:46'!
iconNamed: aSymbol
	^ Icons at: aSymbol ifAbsentPut: [ self findIcon: aSymbol ]! !

!WAPharoToolsIcons class methodsFor: 'initialization' stamp: 'StephanEggermont 8/31/2012 17:46'!
initialize
	Instance := nil.
	Icons := IdentityDictionary new! !

ComposableModel subclass: #WAPharoServerAdapterSpecBrowser
	instanceVariableNames: 'listModel textModel toolbarModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAPharoServerAdapterSpecBrowser class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 14:59'!
defaultSpec
	^{#ComposableSpec.
		#add:. {{#model. #listModel}.
			#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 1@0.5).	(0@0 corner: 0@(-15)). }}.
		#add:. {{#model. #toolbarModel}.
			#layout:. {#FrameLayout.
				#fractions:offsets:. 	(0@0.5 corner: 1@0.5).	(0@(-15) corner: 0@15). }}.															
		#add:. {{#model. #textModel}.
			#layout:. {#FrameLayout.
				#fractions:offsets:. 	(0@0.5 corner: 1@1).	(0@15 corner: 0@0). }}.}! !

!WAPharoServerAdapterSpecBrowser class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:55'!
example

	| mb |
	mb := WAPharoServerAdapterSpecBrowser new.
	mb openWithSpec.
	mb adapters:  (WAServerManagerNode on: WAAdmin defaultServerManager) adaptors
! !

!WAPharoServerAdapterSpecBrowser class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 14:50'!
title
	^'Seaside Control Panel'! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:50'!
adapters: aList
	self listModel items: aList! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 17:40'!
initializeWidgets

	self instantiateModels: #(
		listModel IconListModel
		textModel TextModel
		toolbarModel WAServerAdapterToolbar ).
	
	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel.
	
	textModel aboutToStyle: false.
	listModel displayBlock: [:item | item name].
	listModel whenSelectedItemChanged: [:selection |
        selection
            ifNil: [
			textModel text: ''.
                textModel behavior: nil ]
             ifNotNil: [:adaptorContainer | |adaptor|
			adaptor := adaptorContainer adaptor.		
                textModel text: (String streamContents: [ :stream |
		stream 
			nextPutAll: 'Type: '; nextPutAll: adaptor class name; nextPut: Character cr;
			nextPutAll: 'Port: '; nextPutAll: adaptor port greaseString; nextPut: Character cr;
			nextPutAll: 'Encoding: '; nextPutAll: adaptor codec name; nextPut: Character cr.
		adaptor additionalStatusOn: stream.
		stream
			nextPutAll: adaptor statusString ]).
                 ]].! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 14:59'!
listModel
	^listModel! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 15:00'!
textModel
	^textModel! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 15:00'!
toolbarModel
	^toolbarModel! !

ComposableModel subclass: #WAServerAdapterToolbar
	instanceVariableNames: 'startButton stopButton browseButton startAction stopAction browseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAServerAdapterToolbar class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:27'!
defaultSpec
	<spec>
	^{ #Panel.
			#changeTableLayout.
			#listDirection:. #rightToLeft.
			#addMorph:. {#model. #startButton.}.
			#addMorph:. {#model. #stopButton.}.
			#addMorph:. {#model. #browseButton.}.
			#hResizing:. #spaceFill.
			#vResizing:. #shrinkWrap. }! !

!WAServerAdapterToolbar class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:20'!
title
	^'Server adapter toolbar'! !

!WAServerAdapterToolbar methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:26'!
browseButton
	^browseButton! !

!WAServerAdapterToolbar methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:12'!
initialize
	super initialize.
	startAction := [true] asValueHolder.
	stopAction := [true] asValueHolder.
	browseAction := [true] asValueHolder.! !

!WAServerAdapterToolbar methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:25'!
initializeWidgets
	self instantiateModels: #(startButton ButtonModel).
	self registerStartButtonEvents.
	self focusOrder add: startButton.
	self instantiateModels: #(stopButton ButtonModel).
	self registerStopButtonEvents.
	self focusOrder add: stopButton.
	self instantiateModels: #(browseButton ButtonModel).
	self registerBrowseButtonEvents.
	self focusOrder add: browseButton.
	! !

!WAServerAdapterToolbar methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:16'!
registerBrowseButtonEvents

	browseButton 
		label: 'Browse';
		enabled: true;
		state: false! !

!WAServerAdapterToolbar methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:16'!
registerStartButtonEvents

	startButton 
		label: 'Start';
		enabled: true;
		state: false! !

!WAServerAdapterToolbar methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:16'!
registerStopButtonEvents

	stopButton 
		label: 'Stop';
		enabled: true;
		state: false! !

!WAServerAdapterToolbar methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:26'!
startButton
	^startButton! !

!WAServerAdapterToolbar methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/31/2012 16:26'!
stopButton
	^stopButton! !
WAPharoToolsIcons initialize!
